type
 value=integer;
{$ifdef win32}
 u_val=integer;
{$else}
 u_val=word;
{$endif}

{---------------------------------------------------}
{--  kalkulacni a analyzacni a cachovaci funkce   --}
{---------------------------------------------------}

{prepocita ith pole, cili piskvorky nad kteryma vubec stoji za to premejslet}
procedure recalcbx(x,y:byte);
var
 ox,oy:integer;
 bx1,bx2,by1,by2:integer;
begin
 bx1:=x-bound;if bx1<0 then bx1:=0;
 by1:=y-bound;if by1<0 then by1:=0;
 bx2:=x+bound;if bx2>svrec.px then bx2:=svrec.px;
 by2:=y+bound;if by2>svrec.px then by2:=svrec.px;
 for ox:=bx1 to bx2 do
 for oy:=by1 to by2 do ith[ox,oy]:=1;
end;

{volat pred calcvid/calcsvid/analyze - nastavi ukazatele}
procedure xpointer(x,y:byte);
begin
 xpqs:=_pqs[x,y];{pocet piskvorek smerem od policka s toleranci jedne mezery}
 xsps:=_sps[x,y];{pocet mezer za nimi}
 xpq:=_pq[x,y];{pocet piskvorek smerem od policka}
 xsp:=_sp[x,y];{pocet mezer za nimi}
 xpqsc:=_pqsc[x,y];
end;

{tohle zanalyzuje momentalni policko na pritomnost vidli a podobnych
 fatalnich kombinaci (inteligence 1 - ta stara)
 - tohle je prvni cast ve stare inteligenci - vidlicky bez mezerou}
procedure calcvid;
var
 vp,i,ant_i,vs:integer;
begin
 for vp:=0 to 1 do
 begin
  vidp[vp,0]:=0;
  vidp[vp,1]:=0;
  for i:= 0 to 3 do
  begin
   ant_i:=ant[i];
   xp1:=xpq^[vp,i]+xpq^[vp,ant_i];
   if (xp1)>=vidp[vp,0] then
   begin
    vidp[vp,0]:=xp1;
    xs1:=xsp^[vp,i];xs2:=xsp^[vp,ant_i];
    vidm[vp,0]:=(ord(xs1>=1)+ord(xs2>=1));
    vidc[vp,0]:=xs1+xs2;
    vs:=i;
   end;
  end;
 for i:= 0 to 3 do
 begin
  ant_i:=ant[i];
  xp1:=xpq^[vp,i]+xpq^[vp,ant_i];
  if (xp1>=vidp[vp,1])and(i<>vs) then
  begin
   vidp[vp,1]:=xp1;
   xs1:=xsp^[vp,i];xs2:=xsp^[vp,ant_i];
   vidm[vp,1]:=(ord(xs1>=1)+ord(xs2>=1));
   vidc[vp,1]:=xs1+xs2;
  end;
 end;
end;
end;

{tohle zanalyzuje momentalni policko na pritomnost vidli a podobnych
 fatalnich kombinaci (inteligence 1 - ta stara)
 - tohle je druha cast ve stare inteligenci.
 v podstate vidle s mezerami}
procedure calcsvid;
var
 vp,i,j,vs:integer;
begin
 for vp:=0 to 1 do
 begin
  sidp[vp,0]:=0;
  sidp[vp,1]:=0;
  for j:= 0 to 3 do
  begin
   xp1:=xpqs^[vp,j]+xpq^[vp,ant[j]];
   xp2:=xpqs^[vp,ant[j]]+xpq^[vp,j];
   if xp1>=xp2 then i:=j else begin i:=ant[j]; xp1:=xp2; end;
   if xp1>=sidp[vp,0] then
   begin
    sidp[vp,0]:=xp1;
{    xs1:=xsps^[vp,i];xs2:=xsp^[vp,ant[i]];
    sidm[vp,0]:=(ord(xs1>=1)+ord(xs2>=1));
    sidc[vp,0]:=xs1+xs2;}{tyhle hodnoty nas nezajimaj}
    vs:=i;
   end;
  end;
  for j:= 0 to 3 do
  begin
   xp1:=xpqs^[vp,j]+xpq^[vp,ant[j]];
   xp2:=xpqs^[vp,ant[j]]+xpq^[vp,j];
   if xp1>=xp2 then i:=j else begin i:=ant[j]; xp1:=xp2; end;
   if (xp1>=sidp[vp,1])and(i<>vs) then
   begin
    sidp[vp,1]:=xp1;
{    xs1:=xsps^[vp,i];xs2:=xsp^[vp,ant[i]];
    sidm[vp,1]:=(ord(xs1>=1)+ord(xs2>=1));
    sidc[vp,1]:=xs1+xs2;}{tyhle hodnoty nas nezajimaj}
   end;
  end;
 end;
end;

{need to call xpointer before analyze;}
{tohle zanalyzuje momentalni policko na pritomnost vidli a podobnych
 fatalnich kombinaci (inteligence 2-5)}
procedure analyze;
var
 s,ant_s,p,xpq0,xsp0,xspc,xpq1,xpq2:byte;
 xpqa,xpqb:byte;
 typ:integer;
begin
 fillchar(ctyp,sizeof(ctyp),0);{vynulovat vsechno}
 for s:=0 to 3 do{4 smery}
 for p:=0 to 1 do{2 hraci}
 begin
  {TODO: tohle by se tam mozna hodilo dodat ... uvidim ....}
(*  {SM-? kombibrzdic - aspon neco(casem ovsem nejak upravim prioritu - 6000}
    if (vidp[cp2,0]>=3) and (vidp[cp1,0]>=3) and (vidm[cp1,0]>=1)
    then cv:=4000;
    {SM-? kombividle/brzda - no dame to tam!  - 27000}
    if (vidp[cp2,0]>=3) and (vidp[cp1,0]>=3) and (vidm[cp2,0]>=1) and (vidm[cp1,0]>=1)
    then cv:=6000; *)
  ant_s:=ant[s];
  xpqa:=xpq^[p,s];
  xpqb:=xpq^[p,ant_s];
  xpq0:=xpqa+xpqb;
  xs1:=xsp^[p,s];
  xs2:=xsp^[p,ant_s];
  xsp0:=xs1+xs2;
  xspc:=(ord(xs1>=1)+ord(xs2>=1));
  xpq1:=xpqs^[p,s];
  xpq2:=xpqs^[p,ant_s];
  if xpq0>=4 then typ:=10 else
  if (xpq0=3)and (xspc>=2)and (xsp0>=2) then typ:=8 else
  if (xpq0>=2)and (xpq1>=xpqa+2)and (xpq2>=xpqb+2) then typ:=8 else
  if (xpq0=3)and (xsp0>=1) then typ:=5 else
  if (xpq1+xpqb>=4)or(xpq2+xpqa>=4) then typ:=5 else
  if (xpq0>=2)and (xspc>=2)and (xsp0>=3) then typ:=3 else
  if ((xpq1+xpqb>=3)and(xsps^[p,s]>=1)and(xs2>=1))
  or ((xpq2+xpqa>=3)and(xsps^[p,ant[s]]>=1)and(xs1>=1)) then typ:=3 else typ:=0;
  inc(ctyp[typ,p]);
 end;
end;

{---------------------------------}
{--    premysleci funkce       ---}
{---------------------------------}

function squarevalue_ai2:value;{value: minimum:0 maximum:184 common: 0-51}
var
 mncv:value;
 i:u_val;
begin
 mncv:=0;
 for i:=0 to 7 do inc(mncv,sqr(xpq^[cp2,i]+1)+sqr(xpq^[cp1,i]+1)-2);
 squarevalue_ai2:=mncv;
end;

function squarevalue_ai3:value;{value: minimum:0 maximum:??? common: 18-144}
var
 mncv:value;
 i:u_val;
begin
 mncv:=0;
 for i:=0 to 7 do inc(mncv,sqr(xpq^[cp2,i]+1)+sqr(xpqs^[cp2,i]+1)+sqr(xpqs^[cp1,i]+1)+sqr(xpq^[cp1,i]+1)-4);
 squarevalue_ai3:=mncv;
end;

function squarevalue_ai4:value;{value: minimum:0 maximum:??? common:33-413}
var
 mncv:value;
 s1,s2,i:u_val;
begin
 mncv:=0;
 for i:=0 to 7 do begin
  s1:=2*xsp^[cp1,i]+2;
  s2:=2*xsp^[cp2,i]+2;
  if s1>6 then s1:=6;if s2>6 then s2:=6;{5 misto 6 -> 2.5 spaces na konci rady misto 3}
  inc(mncv,sqr(xpq^[cp2,i])*s2+3*sqr(xpqs^[cp2,i]+1)+sqr(xpq^[cp1,i])*s1+3*sqr(xpqs^[cp1,i]+1)-6);
 end;
 squarevalue_ai4:=mncv;
end;

procedure init_move_ai5;
begin
 if svrec.tahy<7 then begin {upravy podle pokrocilosti hry}
  s3:=2;s4:=1;
 end else if svrec.tahy<12 then begin
  s3:=2;s4:=2;
 end else if svrec.tahy<18 then begin
  s3:=3;s4:=3;
 end else begin
  s3:=3;s4:=4;
 end;
end;

function squarevalue_ai5:value;{value: minimum:0 maximum:??? common:3-4827}
var
 mncv:value;
 i:u_val;

{Vlozka ze staryho - spocita qx,qy
 - tyhle dva koeficienty se pak pouzijou pozdejc}
procedure calculate_qx_qy;
begin
 s1:=2*xsp^[cp1,i]+2;
 s2:=2*xsp^[cp2,i]+2;
 s1a:=2*xsp^[cp1,ant_i]+2;
 s2a:=2*xsp^[cp2,ant_i]+2;
 if svrec.px>=15 then begin {upravy algoritmu podel velikosti hraciho pole}
  if s1>5 then s1:=5;if s2>5 then s2:=5;
  if s1a>5 then s1a:=5;if s2a>5 then s2a:=5;
 end else begin
  if s1>6 then s1:=6;if s2>6 then s2:=6;
  if s1a>6 then s1a:=6;if s2a>6 then s2a:=6;
 end;
 qx:=sqr(xpq^[cp1,i])*s1+sqr(xpq^[cp1,ant_i])*s1a
     +s3*sqr(xp1+1)+s3*sqr(xp1a+1)+s3{}*2{}*(xpqsc^[cp1,ant_i]+xpqsc^[cp1,i])
     +(1-(i and 1))*(sqr(xpqs^[cp1,i])+sqr(xpqs^[cp1,ant_i])div s4);
 qy:=sqr(xpq^[cp2,i])*s2+sqr(xpq^[cp2,ant_i])*s2a
     +s3*sqr(xp2+1)+s3*sqr(xp2a+1)+s3{}*2{}*(xpqsc^[cp2,ant_i]+xpqsc^[cp2,i])
     +(1-(i and 1))*(sqr(xpqs^[cp2,i])+sqr(xpqs^[cp2,ant_i])div s4);

end;

begin
 mncv:=0;
 for i:=0 to 3 do begin
  ant_i:=ant[i];
  xp1:=xpqs^[cp1,i];xp1a:=xpqs^[cp1,ant_i];
  xp2:=xpqs^[cp2,i];xp2a:=xpqs^[cp2,ant_i];
  xs1:=xsps^[cp1,i];xs1a:=xsps^[cp1,ant_i];
  xs2:=xsps^[cp2,i];xs2a:=xsps^[cp2,ant_i];
  if ((xp1+xp1a+xs1+xs1a)>4) or ((xp2+xp2a+xs2+xs2a)>4) then begin
   calculate_qx_qy;
   if cp1=0 then begin {1 hrac}
    inc(xp1,self_func[xpq^[cp1,ant_i]]);{normal}
    inc(xp1a,self_func[xpq^[cp1,i]]);{nutno prevratit}
   end else begin
    inc(xp1,xpq^[cp1,ant_i]);{normal}
    inc(xp1a,xpq^[cp1,i]);{nutno prevratit}
   end;
   if xp1<xp1a then begin {zmena smeru}
    xp1:=xp1a;
    i1:=ant_i;
    i1a:=i;
   end else begin
    i1:=i;
    i1a:=ant_i;
   end;
   {2 hrac}
   xp2:=xp2+xpq^[cp2,ant_i];{normal}
   xp2a:=xp2a+xpq^[cp2,i];{nutno prevratit}
   if xp2<xp2a then begin {zmena smeru}
    xp2:=xp2a;
    i2:=ant_i;
    i2a:=i;
   end else begin
    i2:=i;
    i2a:=ant_i;
   end;
   {konec}
   s1:=(xsps^[cp1,i1]+xsp^[cp1,i1a])*2+7;
   s2:=(xsps^[cp2,i2]+xsp^[cp2,i2a])*2+7;
   if s1>15 then s1:=15;if s2>15 then s2:=15;
   inc(mncv,(sqr(xp1)*s1+14*(xp1))div 3+sqr(xp1+1) div 2+qx*8);
   inc(mncv,(sqr(xp2)*s2+14*(xp2))div 3+sqr(xp2+1) div 2+qy*8);
  end else inc(mncv,xp1+xp2+xp1a+xp2a);
 end;
 squarevalue_ai5:=mncv;
end;

const _v_s=4666;

function vidlarna_ai2345(mncv:value):value;
var cv:value;
begin
 cv:=0;
 if mncv>=_v_s then mncv:=_v_s-1;
 if (ctyp[3,cp2]>=2) then cv:=1*_v_s; {trap 2xtwo SM2}
 if (ctyp[3,cp1]>=2) then cv:=2*_v_s; {trap 2xtwo SM2}
 if (ctyp[5,cp2]>=1)and(ctyp[3,cp2]>=1) then cv:=3*_v_s; {trap three+two SM1.5}
 if ctyp[8,cp2]>=1 then cv:=4*_v_s; {put four SM1}
 if ctyp[5,cp2]>=2 then cv:=4*_v_s; {trap 2xthree SM1}
 if (ctyp[5,cp1]>=1)and(ctyp[3,cp1]>=1) then cv:=5*_v_s; {trap three+two SM1.5}
 if ctyp[8,cp1]>=1 then cv:=6*_v_s; {put four SM1}
 if ctyp[5,cp1]>=2 then cv:=6*_v_s; {trap 2xthree SM1}
 cv:=cv+mncv;
 if ctyp[10,cp1]>=1 then cv:=32767; {put five SM0}
 if ctyp[10,cp2]>=1 then cv:=32766; {put five SM0}
 vidlarna_ai2345:=cv;
end;

function vidlarna_ai01(mncv:value):value;
var i:u_val;
begin
 cv:=0;
 {pozn. SM-2 =smrt ve dvou dalsich tazich}
 { SM-? kombibrzdic - aspon neco(casem ovsem nejak upravim prioritu}
 if piq>1 then if (vidp[cp2,0]>=3) and (vidp[cp1,0]>=3) and (vidm[cp1,0]>=1)
 then cv:=4000;
 { SM-? kombividle/brzda - no dame to tam!}
 if piq>1 then if (vidp[cp2,0]>=3) and (vidp[cp1,0]>=3) and (vidm[cp2,0]>=1) and (vidm[cp1,0]>=1)
 then cv:=6000;
 {SM-2  mensi vidle, musi pryc}
 if(vidp[cp2,0]>=2) and (vidp[cp2,1]>=2) and (vidm[cp2,0]>=2) and (vidm[cp2,1]>=2) and (vidc[cp2,0]>=3) and (vidc[cp2,1]>=3)
 then cv:=8000;
 {SM-2  mensi vidle, taky dobry}
 if(vidp[cp1,0]>=2) and (vidp[cp1,1]>=2) and (vidm[cp1,0]>=2) and (vidm[cp1,1]>=2) and (vidc[cp1,0]>=3) and (vidc[cp1,1]>=3)
 then cv:=11000;
 {SM-1.5 Past+vidle (stredni vidle), bacha na ne}
 if(vidp[cp2,0]>=3) and (vidp[cp2,1]>=2) and (vidm[cp2,0]>=1) and (vidm[cp2,1]>=2) and (vidc[cp2,1]>=3)
 then cv:=20000;
 {SM-1 likvidovat past (tri za sebou)}
 for i:=0 to 3 do if (xpq^[cp2,i]+xpq^[cp2,ant[i]]>=3)
 and (xsp^[cp2,i]>=1) and(xsp^[cp2,ant[i]]>=1) then cv:=22000;
 { SM-1 special past liqidovat}
 if piq>1 then for i:=0 to 3 do if (xpqs^[cp2,i]>=3)and (xpqs^[cp2,ant[i]]>=3)
 and (xpq^[cp2,i]>=1) and(xpq^[cp2,ant[i]]>=1) then cv:=22500;
 {SM-1.5 Past+vidle (stredni vidle), uz tam jsou}
 if(vidp[cp1,0]>=3) and (vidp[cp1,1]>=2) and (vidm[cp1,0]>=1) and (vidm[cp1,1]>=2) and (vidc[cp1,1]>=3)
 then cv:=24000;
 {SM-1 zkusit past (tri za sebou)}
 for i:=0 to 3 do if (xpq^[cp1,i]+xpq^[cp1,ant[i]]>=3)
 and (xsp^[cp1,i]>=1) and(xsp^[cp1,ant[i]]>=1) then cv:=26000;
 { SM-1 special past udelat}
 if piq>1 then for i:=0 to 3 do if (xpqs^[cp1,i]>=3)and (xpqs^[cp1,ant[i]]>=3)
 and (xpq^[cp1,i]>=1) and(xpq^[cp1,ant[i]]>=1) then cv:=26500;
 { SM-1 varianta spaces 5/5 s mezerou}
 if piq>1 then if (sidp[cp2,0]>=4) and (sidp[cp2,1]>=4)
 then cv:=27500;
 {SM-1 cizi vidle-likvidovat}
 if (vidp[cp2,0]>=3) and (vidp[cp2,1]>=3) and (vidm[cp2,0]>=1) and (vidm[cp2,1]>=1)
 then cv:=28000;
 { SM-1 varianta spaces 5/5 s mezerou}
 if piq>1 then if (sidp[cp1,0]>=4) and (sidp[cp1,1]>=4)
 then cv:=29500;
 {SM-1 svoje vidle-uplatnit}
 if (vidp[cp1,0]>=3) and (vidp[cp1,1]>=3) and (vidm[cp1,0]>=1) and (vidm[cp1,1]>=1)
 then cv:=30000;
 {no a jelikoz hloupejsi algoritmus se mi vymyslet nepodarilo,
  tak tam musim vlozit blbost umele:}
 if (piq=1) then begin
  case random(5) of {tadyhle podceni nebo uplne prehlidne vidlicky}
   1:cv:=cv div 20;
   2:cv:=cv div 400;
   3:cv:=cv div 8000;
   4:if not((cv=22000) or (cv=26000)) then cv:=0 else cv:=cv div 1000;{"tri za sebou" se neprehlizi}
   {no neceho si i vsimne ;-)}
  end;
  case random(4) of {nejak se mu pochroumal odhad...}
   1:mncv:=mncv div 3;
   2:mncv:=mncv*3;
   3:mncv:=0;
  end;
  if mncv>2700 then mncv:=2700;
  if mncv<0 then mncv:=0;
 end;{end of stupidity}
 cv:=cv+mncv;
 {SM-0 zabranit druhymu udelat pet - 32766}
 for i:=0 to 3 do if xpq^[cp2,i]+xpq^[cp2,ant[i]]>=4 then cv:=32766;
 {SM-0 udelat pet - 32767}
 for i:=0 to 3 do if xpq^[cp1,i]+xpq^[cp1,ant[i]]>=4 then cv:=32767;
 vidlarna_ai01:=cv;
end;


procedure new_ai_core_calculate;
begin
 xpointer(ix,iy);
 analyze;
 case piq of
  3:mncv:=squarevalue_ai2;
  4:mncv:=squarevalue_ai3;
  5:mncv:=squarevalue_ai4;
  6:mncv:=squarevalue_ai5;
 end;
 cv:=vidlarna_ai2345(mncv);
end;

procedure old_ai_core_calculate;
begin
 xpointer(ix,iy);
 calcvid;
 if piq>1 then calcsvid;
 mncv:=squarevalue_ai2;{piskvorky nekde - teoreticky max 184}
 cv:=vidlarna_ai01(mncv);
end;

procedure check_if_greater_value;
begin
 if (cv>mxv)or ((cv=mxv) and (random(3)=0)) then begin
  mxx:=ix;
  mxy:=iy;
  mxv:=cv;
 end;
end;

{prvni tah jde "nekam doprostred"}
procedure make_first_move;
begin
 mxx:=svrec.px div 2;
 mxy:=svrec.px div 2;
 mxv:=32000;
end;

{dalsi jde vedle toho prvniho, ale pokud druhy tahne
 na okraji tak na nej kaslu a dam to doprostred}
procedure make_begin_game_near_move;
begin
 for mx:=0 to svrec.px do for my:=0 to svrec.px do
 if (mp[mx,my]<>0) then begin
  mxx:=mx;
  mxy:=my;
 end;
 mxv:=32000;
 if (mxx<=1) or(mxy<=1) or(mxx>=svrec.px-1) or(mxy>=svrec.px-1) then begin
  mxx:=svrec.px div 2+random(2);
  mxy:=svrec.px div 2+random(2);
 end else begin
  repeat
   cv:=random(8);
   mxx:=mxx+rvx[cv];
   mxy:=mxy+rvy[cv];
  until (mp[mxx,mxy]=0);
 end;
end;

procedure computer_play; {jadro premysleni pro inteligence 1-5}
begin
 cp1:=svrec.cp-1;
 cp2:=2-svrec.cp;
 case svrec.tahy of
  0:make_first_move;{prvni tah-doprostred}
  1,2:make_begin_game_near_move{dalsi dva-nekam vedle}
  else begin
   mxv:=-1;
   if piq=6 then init_move_ai5;
   for ix:=0 to svrec.px do for iy:=0 to svrec.px do
   {muzu to sem soupnout? - ma li to smysl?}
   if (mp[ix,iy]=0) and (ith[ix,iy]=1)then begin{TEST POLICKA (HLAVNI CAST)}
    if piq>=3 then new_ai_core_calculate else old_ai_core_calculate;
    check_if_greater_value;
   end;
  end;
 end;{of case}
end;

{
const
 maxmncv:value=-30000;
 minmncv:value= 30000;
procedure debug_print;
begin
 outtext(YRES+8,YRES-32,$1a,'Max()='+strl(maxmncv));
 outtext(YRES+8,YRES-16,$1a,'Min()='+strl(minmncv));
end;

procedure debug_mncv;
begin
 if mncv>maxmncv then maxmncv:=mncv;
 if mncv<minmncv then minmncv:=mncv;
end;
}